import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import '../System/Ev_Global.dart';
import '../System/Ev_Lang.dart';

//enum Ev_Alert_Button { None,Button1,Button2,Ok,Confirm ,Yes,No}

class Ev_Alert
{
   static void Error(BuildContext context,String message,{String close_text="",onclose})
    { showDialog<String>(
         context: context,
         barrierDismissible: false,
         builder: (BuildContext context) {
           var dialog = new CupertinoAlertDialog (
              title: new Icon(Icons.highlight_off,color: Colors.red,size: 50,),
              content: new Text(message),
              actions: <Widget>[
                CupertinoDialogAction(isDefaultAction: true,
                  child: Text(close_text == "" ? lang_close[Ev_Lang.lang_id] : close_text,style: TextStyle(color:Colors.black26),),
                onPressed: () {
                Navigator.pop(context);
                if(onclose != null)
                {  onclose(); }
             },
            )
          ],
        );
       return dialog;
      }
     );
   }


   static void Success(BuildContext context,String message,{String close_text="",onclose})
   { showDialog<String>(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
         var dialog =  WillPopScope(
             onWillPop: () {},

         child: CupertinoAlertDialog (
           title: Icon(Icons.check_circle_outline,color: Colors.green, size: 50,),
           content: Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(close_text == "" ? lang_close[Ev_Lang.lang_id] : close_text,style: TextStyle(color:Colors.black26),),
               onPressed: () {
                 Navigator.pop(context);
                 if(onclose != null)
                    {  onclose(); }
               },
             )
           ],
         ));
         return dialog;
       }
     );
   }


   static void Warning(BuildContext context,String message,{String close_text="",onclose})
   { showDialog<String>(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
         var dialog = new CupertinoAlertDialog (
           title: new Icon(Icons.error_outline,color: Colors.amber,size: 50,),
           content: new Text(message),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: Text(close_text == "" ? lang_close[Ev_Lang.lang_id] : close_text,style: TextStyle(color:Colors.black26),),
               onPressed: () {
                 Navigator.pop(context);
                 if(onclose != null)
                   {  onclose(); }
               },
             )
           ],
         );
         return dialog;
       }
   );
   }


   static void Confirm(BuildContext context,String title,String message,{confirm_text="",cancel_text="",onconfirm})
    {  showDialog(
       context: context,
       barrierDismissible: true,
       builder: (BuildContext context) {
         var dialog = CupertinoAlertDialog (
           title: Text(title,style:TextStyle(fontSize: 16)),
           content: Text(message,style: TextStyle(fontSize: 12),),
           actions: <Widget>[
             CupertinoDialogAction(isDefaultAction: true,
               child: confirm_text == "" ? Text(lang_confirm[Ev_Lang.lang_id]) : Text(confirm_text),
               onPressed: () {
                 Navigator.pop(context);
                 if(onconfirm != null)
                 {  onconfirm(); }
               },
             ),
             CupertinoDialogAction(
               child: cancel_text == "" ? Text(lang_cancel[Ev_Lang.lang_id],style:TextStyle(color:Colors.grey)) :
                Text(cancel_text,style:TextStyle(color:Colors.grey)),
         onPressed: () {
                 Navigator.pop(context);
               },
              )
             ],
           );
         return dialog;
        });
   }


   static void YesNo(BuildContext context,String title,String message,{String yes_text="",String no_text="",onyes,onNo})
   {  showDialog(
       context: context,
       barrierDismissible: false,
       builder: (BuildContext context) {
       var dialog =
         WillPopScope(
           onWillPop: () { print("Back Press");},
           child: CupertinoAlertDialog (
             title: Text(title,style:TextStyle(fontSize: 16)),
             content: Text(message,style: TextStyle(fontSize: 12),),
             actions: <Widget>[
               CupertinoDialogAction(isDefaultAction: true,
                 child: yes_text == "" ? Text(lang_yes[Ev_Lang.lang_id]) : Text(yes_text),
                 onPressed: () {
                   Navigator.pop(context);
                   if(onyes != null)
                   {  onyes(); }
                 },
               ),
               CupertinoDialogAction(
                 child: no_text == "" ? Text(lang_no[Ev_Lang.lang_id],style:TextStyle(color:Colors.grey)) :
                 Text(no_text,style:TextStyle(color:Colors.grey)),
             onPressed: () {
                   Navigator.pop(context);
                   if(onNo != null)
                   {  onNo(); }
                 },
               )
             ],
           ),
         );
         return dialog;
       });
   }



}