import '../Elves.dart';
import '../System/Ev_Global.dart';
import '../System/Ev_Lang.dart';
import 'package:flutter/material.dart';
import '_Ev_Send_query.dart';
import 'package:path/path.dart';

class $EV_Send_File extends StatefulWidget {
  var url;
  var sdata;
  var post;
  var onSuccess;
  var fontcolor;
  Color bgcolor;

  var error = false;
  var success = false;
  var visible = 0.5;
  var api_loaded = false;

  Send_Query send_query;

  $EV_Send_File({this.fontcolor,this.bgcolor,this.url,this.post,this.sdata,this.onSuccess,this.send_query,Key key}):super(key:key);

  @override
  _$EV_Send_FileState createState() => _$EV_Send_FileState();
}

class _$EV_Send_FileState extends State<$EV_Send_File> implements Send_Return {

  var percent = "0%";
  var E = Ev_Widget();

  @override
  Widget build(BuildContext context) {
    if(!widget.api_loaded)
    {  widget.api_loaded = true;
    widget.send_query.add(widget.url, widget.post, {"photo":widget.sdata["file"]}, this);
    }

    if(widget.error)
    {  return Container(
      padding: EdgeInsets.all(5),
      width: 120,
      child: Row(children: <Widget>[
        Icon(Icons.error,color: Colors.amber,size: 25,),
        SizedBox(width: 5,),
        Text(Ev_Send_Error[Ev_Lang.lang_id],style: TextStyle(color: Colors.black)),
      ],),
    );
    }
    else
    {  return body(); }
  }

  Widget body(){
    return ClipRRect(
        borderRadius: BorderRadius.circular(5.0),
        child: Stack(
          children: <Widget>[
            Container(
                color: widget.bgcolor.withOpacity(widget.visible),
                constraints: BoxConstraints(
                  maxWidth: 200,
                  minWidth: 100,),

                padding: EdgeInsets.all(8.0),
                child: Column(children: <Widget>[
                  SizedBox(height: 2,),
                  Row(children: <Widget>[
                    Opacity(
                      opacity: widget.visible,
                      child: ClipRRect(borderRadius: BorderRadius.circular(15.0),
                          child: Container(width: 30, height: 30,
                            color: Colors.blue,
                            child: Center(child: Icon(
                                Icons.insert_drive_file, size: 20,
                                color: Colors.white)),)
                      ),
                    ),
                    SizedBox(width: 8,),
                    Expanded(
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                        Text(basename(widget.sdata["file"].path),
                          style: TextStyle(color: widget.fontcolor.withOpacity(widget.visible)),overflow: TextOverflow.ellipsis,),
                          E.Build.Text(key:"percent",text: percent,textStyle: TextStyle(color:Colors.black,fontSize: 12)),
                      ],),
                    )
                  ],),
                ],)),
            Positioned(right:10, bottom:5,
                child: Text(widget.sdata["time"], style: TextStyle(fontSize: 10, color: widget.fontcolor.withOpacity(0.7)),)),

          ],
        ));
     }


  @override
  void error_return() {
    setState(() {
      widget.error = true;
    });
  }

  @override
  void process_return(send, total) {
    print("Proccess $send, $total");
    percent = (send/total * 99).round().toString() + "%";
    E.Widget["percent"].text = percent;
  }

  @override
  void success_return(data) {
    setState(() {
      percent = "100%";
      widget.visible = 1;
      widget.onSuccess(data);
    });
  }

}
