import '../Image/Ev_PhotoView.dart';
import '../System/Ev_Global.dart';
import '../System/Ev_Lang.dart';
import '../System/Ev_Page.dart';
import 'package:flutter/material.dart';
import '_Ev_Send_query.dart';

class $EV_Send_Photo extends StatefulWidget {
  var url;
  var sdata;
  var post;
  var onSuccess;
  var fontcolor;
  var bgcolor;

  var error = false;
  var success = false;
  var visible = 0.5;
  var api_loaded = false;

  Send_Query send_query;

  $EV_Send_Photo({this.fontcolor,this.bgcolor,this.url,this.post,this.sdata,this.onSuccess,this.send_query,Key key}):super(key:key);

  @override
  _$EV_Send_PhotoState createState() => _$EV_Send_PhotoState();
}

class _$EV_Send_PhotoState extends State<$EV_Send_Photo> implements Send_Return {

  var percent = "0%";

  @override
  Widget build(BuildContext context) {
    if(!widget.api_loaded)
       {  widget.api_loaded = true;
          widget.send_query.add(widget.url, widget.post, {"photo":widget.sdata["photo"]}, this);
       }

    if(widget.error)
    {  return Container(
      padding: EdgeInsets.all(5),
      width: 120,
      child: Row(children: <Widget>[
        Icon(Icons.error,color: Colors.amber,size: 25,),
        SizedBox(width: 5,),
        Text(Ev_Send_Error[Ev_Lang.lang_id],style: TextStyle(color: Colors.black)),
      ],),
      );
    }
    else
    {  return body(); }
  }


  Widget body()
  {  return GestureDetector(
    child: Card(
          child: ClipRRect(
          borderRadius: BorderRadius.circular(5.0),
           child: Container(
            width: 210,
            height: 210,
            color: widget.bgcolor,
            padding: EdgeInsets.all(4.0),

            child: Stack(children: <Widget>[
              ClipRRect(
                borderRadius: BorderRadius.circular(2),
                child: Image.file(widget.sdata["photo"],width: 200,height: 200, fit: BoxFit.cover,)),

              Positioned(right: 5, bottom: 0,
              child: Padding(
                padding: const EdgeInsets.all(5.0),
                child: Text(widget.sdata["time"],
                    style: TextStyle(fontSize: 10, color: Colors.white)),
              ),),
            (widget.success) ? Container() :
              Container(width: 200, height: 200,
                color: Colors.black.withOpacity(0.7),
                child:Center(child: Text(percent,style: TextStyle(color:Colors.white,fontWeight: FontWeight.bold))))
            ],),


          )),
    ),

    onTap: (){
        if(widget.success)
          {  Ev_Page.open(context, Ev_PhotoView(image:widget.sdata["photo"])); }

    },
  );}

  @override
  void error_return() {
    setState(() {
      widget.error = true;
    });
  }

  @override
  void process_return(send, total) {
      print("Proccess $send, $total");
      setState(() {
        percent = (send/total * 99).round().toString() + "%";
      });
  }

  @override
  void success_return(data) {
     setState(() {
        widget.success = true;
        widget.onSuccess(data);
     });
  }
}
