import 'dart:io';
import '../System/Ev_Lang.dart';
import 'package:flutter/material.dart';
import 'package:image_picker/image_picker.dart';
import '../System/Ev_Global.dart';
import 'dart:async';

import 'Ev_ImageCrop_Page.dart';

class Ev_Image
{
    static Future<File> Get_From_Camera(BuildContext context,{onReceived,double maxWidth=1200,double maxHeight=2000,double crop_ratio = 0}) async
     { var image = await ImagePicker.pickImage(source: ImageSource.camera, maxHeight: maxHeight, maxWidth: maxWidth);
       if (image != null) {
         var output_image = await _get_image(context,image,crop_ratio,maxWidth,maxHeight);
         if(onReceived!=null)
           { onReceived(output_image); }
         return output_image;
       }
     }

    static Future<File> Get_From_Gallery(BuildContext context,{onReceived,double maxWidth=1200,double maxHeight=2000,double crop_ratio = 0}) async
      { var image = await ImagePicker.pickImage(source: ImageSource.gallery, maxHeight: maxHeight, maxWidth: maxWidth);
        if (image != null) {
          var output_image = await _get_image(context,image,crop_ratio,maxWidth,maxHeight);
          if(onReceived!=null)
            { onReceived(output_image); }
          return output_image;
        }

      }

    static Get_Select(BuildContext context,{onReceived,double maxWidth=1200,double maxHeight=2000,camera_text="",gallery_text="",double crop_ratio = 0})
     {  showModalBottomSheet(
            context: context,
            builder: (BuildContext context){
              return  Column(
                mainAxisSize: MainAxisSize.min,
                children: <Widget>[
                  new ListTile(
                      leading: Icon(Icons.camera),
                      title: Text(camera_text == "" ? Ev_lang_camera[Ev_Lang.lang_id] : camera_text),
                      onTap: () async {
                         Navigator.pop(context);
                         Get_From_Camera(context,maxWidth:maxWidth,maxHeight:maxHeight,crop_ratio: crop_ratio,onReceived: onReceived);
                      }
                  ),
                  new ListTile(
                      leading: new Icon(Icons.photo_library),
                      title: Text(gallery_text == "" ? Ev_lang_gallery[Ev_Lang.lang_id] : gallery_text),
                      onTap: () async
                      {  Navigator.pop(context);
                         Get_From_Gallery(context,maxWidth:maxWidth,maxHeight:maxHeight,crop_ratio: crop_ratio,onReceived: onReceived);
                      }
                  ),
                ],
              );
            }
        );
     }

    static Future<File> _get_image(BuildContext context,File image,double crop_ratio,maxwidth,maxheight) async {
      if(crop_ratio == 0 )
         {  return image; }
      else {
         File im =  await Navigator.push(context, MaterialPageRoute(builder: (context) => Ev_ImageCrop_Page(imagefile: image,cropradio: crop_ratio)));
         print("Crop image return : " + im.toString());
         return im;
       }
     }

    static Crop_Image(BuildContext context,File image,double crop_ratio)
    async {
      File im = await Navigator.push(context, MaterialPageRoute(
          builder: (context) =>
              Ev_ImageCrop_Page(imagefile: image, cropradio: crop_ratio)));
      print("Crop image return : " + im.toString());
      return im;
    }

}

