import '../API/Ev_CheckVersion.dart';
import '../Alert/Ev_Alert.dart';
import '../Elves.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'Ev_Firebase.dart';
import 'Ev_Func.dart';
import 'Ev_Global.dart';
import 'Ev_Lang.dart';
import 'Ev_LocalValue.dart';

Ev_Widget Root = Ev_Widget();

class Ev_Main {
  var checkversion_api;
  var app_version;

  Widget default_page;
  var firebase_topic;
  var app_title;
  var themedata;

  String lang;

  Ev_Main(this.default_page, this.app_title, {this.themedata, this.firebase_topic = "", this.lang = Ev_Lang.eng, this.checkversion_api, this.app_version})
  {
    WidgetsFlutterBinding.ensureInitialized();
    SystemChrome.setPreferredOrientations([
      DeviceOrientation.portraitUp,
      DeviceOrientation.portraitDown,
    ]);

    if(firebase_topic!="")
    {  Ev_Firebase.connect(firebase_topic); }

    SharedPreferences.getInstance().then((res) async {
      await Ev_Local.init(res);
      await Ev_Lang.init(lang);
      print("PIA_Main init finish");
      runApp(Ev_Main_Body(default_page,app_title,themedata,checkversion_api,app_version));
    });
  }
}

class Ev_Main_Body extends StatelessWidget {
  var checkversion_api;
  var app_version;
  Widget default_page;
  var firebase_topic;
  var app_title;
  var themedata;

  String lang;

  Ev_Main_Body(this.default_page,this.app_title,this.themedata,this.checkversion_api,this.app_version);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: app_title,
        debugShowCheckedModeBanner: false,
        theme: themedata,
        home: Body(default_page,checkversion_api,app_version)
    );
  }
}

class Body extends StatelessWidget {
  var checkversion_api;
  var app_version;
  Widget default_page;

  Body(this.default_page,this.checkversion_api,this.app_version);

  Future CheckVersion(context)
  async {  var connect = await Ev_Func.Check_network();
  if(connect) {
    if (checkversion_api != null) {
      Ev_CheckVersion(context, checkversion_api, app_version);
    }
  }
  else
  {  Ev_Alert.Warning(context, api_nonetwork[Ev_Lang.lang_id],onclose: (){
    SystemChannels.platform.invokeMethod('SystemNavigator.pop'); });
  }
  }

  @override
  Widget build(BuildContext context) {
    WidgetsBinding.instance.addPostFrameCallback((_) => CheckVersion(context));
    return  Root.Build.Widgets(widget: default_page);
  }
}

