import '../API/Ev_API.dart';
import '../System/Ev_Global.dart';
import '../System/Ev_Lang.dart';
import 'package:flutter/material.dart';

import '../Elves.dart';

class $Ev_Api_ListView extends StatefulWidget {
   var url;
   var post;
   var table_item;
   var pagesize;
   var nodata_text;
   int crossAxisCount;
   double childAspectRatio;
   $Ev_Item evdata;

   $Ev_Api_ListView(this.evdata, {this.url,this.post,this.table_item,this.pagesize = 20,this.nodata_text="",this.crossAxisCount = 0,this.childAspectRatio = 1,Key key}): super(key: key){}

  @override
  _$Ev_Api_ListViewtState createState() => _$Ev_Api_ListViewtState();
}

class _$Ev_Api_ListViewtState extends State<$Ev_Api_ListView> {

  Ev_API api = Ev_API();
  var loaded = false;
  var error = false;
  var page = 1;
  var all_loaded = false;

  List data;

  ScrollController _controller;

  void initState() {
    _controller = ScrollController();
    _controller.addListener(_scrollListener);
  }

  _scrollListener() {
    if (_controller.offset >= _controller.position.maxScrollExtent &&
        !_controller.position.outOfRange) {
         _PageLoad();
    }
    if (_controller.offset <= _controller.position.minScrollExtent &&
        !_controller.position.outOfRange) {
    }
  }

  @override
  void dispose() {
    // TODO: implement dispose
    api.Stop();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if(error)
      {  return _Error_Reload(context); }

    if(!loaded) {
      page = 1;
      var post = widget.post;
      post["pageno"] = "$page";
      post["pagesize"] = widget.pagesize.toString();

      api.Post(widget.url, post: post, alert_error: true,
          onSuccess: (Ev_API_Result result) {
            setState(() {
              data = result.data;
              loaded = true;
              error = false;
            });
          },
          onConnectError: () {
            setState(() {
              error = true;
              loaded = false;
            });
          },
          onReturnError:()
          {  setState((){
            error = true;
            loaded = false;
          });
          }
      );
      return Center(
          child: SizedBox(
              child:
              new CircularProgressIndicator(
                  valueColor: new AlwaysStoppedAnimation(Colors.blue),
                  strokeWidth: 5.0),
              height: 40.0,
              width: 40.0));
    }
   else
    {  if(widget.crossAxisCount >1)
         { return _gridview(); }
       else
         { return _listview(); }
    }
  }

 Widget _gridview()
  {  if(data.length == 0)
      {  return _no_data(); }
    else
      { if(data.length < widget.pagesize)
        { all_loaded = true; }

    return RefreshIndicator(
      onRefresh: () {
        reload(widget.url, widget.post);
      },
      child: GridView.builder(itemCount: data.length,
        controller: _controller,
        gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
            crossAxisCount: widget.crossAxisCount,
            childAspectRatio: widget.childAspectRatio
        ),

        padding: EdgeInsets.all(0),
        physics: const AlwaysScrollableScrollPhysics(),
        itemBuilder: (context, index) {
          if (index == data.length - 1 && !all_loaded) {
            return Column(
              children: <Widget>[
                widget.table_item(data[index]),
                Container(
                  color: Colors.grey.withOpacity(0.2),
                  padding: EdgeInsets.all(10),
                  child: Center(
                      child: SizedBox(
                          child:
                          new CircularProgressIndicator(
                              valueColor: new AlwaysStoppedAnimation(
                                  Colors.black),
                              strokeWidth: 2.0),
                          height: 15.0,
                          width: 15.0)),
                )
              ],
            );
          }
          else
            return widget.table_item(data[index]);
        },
      ));
  }
  }


  Widget _listview()
  {  if(data.length == 0)
       {  return _no_data(); }
     else
       { if(data.length < widget.pagesize)
             { all_loaded = true; }

         return RefreshIndicator(
           onRefresh: () {
             reload(widget.url, widget.post);
           },
          child: ListView.builder
          (itemCount: data.length,
          controller: _controller,
          padding: EdgeInsets.all(0),
          physics: const AlwaysScrollableScrollPhysics(),
          itemBuilder: (context, index) {
            if (index == data.length - 1 && !all_loaded) {
              return Column(
                children: <Widget>[
                  widget.table_item(data[index]),
                  Container(
                    color: Colors.grey.withOpacity(0.2),
                    padding: EdgeInsets.all(10),
                    child: Center(
                        child: SizedBox(
                            child:
                            new CircularProgressIndicator(
                                valueColor: new AlwaysStoppedAnimation(
                                    Colors.black),
                                strokeWidth: 2.0),
                            height: 15.0,
                            width: 15.0)),
                  )
                ],
              );
            }
            else
              return widget.table_item(data[index]);
          },
        ));
     }
  }

  Widget _no_data() {
    var text = widget.nodata_text == ""
        ? tableview_nodata[Ev_Lang.lang_id]
        : widget.nodata_text;
    return Center(child: Text(text),);
  }

  Widget _Error_Reload(BuildContext context)
  {  return Center(child: Column(
    mainAxisAlignment: MainAxisAlignment.center,
    children: <Widget>[
      Icon(Icons.error_outline,color: Colors.amber,size: 110),
      RaisedButton(child: Icon(Icons.refresh,size: 25,),onPressed: (){
        setState(() {
          error = false;
          loaded = false;
        });
      },)
    ],),);
  }

  void _PageLoad()
  { if(all_loaded) return;
     page = page  + 1;
     var post = widget.post;
         post["pageno"] = "$page";
         post["pagesize"] = widget.pagesize.toString();

     api.Post(widget.url, post: post,
      onSuccess: (Ev_API_Result result) {
        setState(() {
          if(result.data.length < widget.pagesize)
             { all_loaded = true; }

          result.data.forEach((dynamic value) {
            data.add(value);
          });
        });
      });
  }

  void reload(url,post)
  {   api.Stop();
      if(url != null)
        {  widget.url = url; }

      if(post != null)
        {  widget.post = post; }

      setState(() {
        data.clear();
        page = 1;
        loaded = false;
        error = false;
        all_loaded = false;
      });

  }
}


